import pandas as pd
import numpy as np
from scipy import optimize

# this code does not consider any initial ratings.  Rather it just obtains a rating based no the current season results.

df = pd.read_csv("nba-201718.csv")
teams = list(set(df.home.unique()) & set(df.away.unique()))


df['hidx'] = df.home.apply(lambda x: teams.index(x))
df['aidx'] = df.away.apply(lambda x: teams.index(x))
df['xhidx'] = df.hidx
df['xaidx'] = df.aidx

n_teams = len(teams)
ghome = n_teams

def constr(x):
    return np.mean(x[:n_teams])


def obj(x):
    err = (((df['GH']-df['GA']) - (x[ghome] + df.xhidx.apply(lambda i: x[i]) - df.xaidx.apply(lambda i: x[i])))**2).sum()
    return err

x0 = np.zeros(shape=len(teams) + 1)

res = optimize.minimize(obj, x0, constraints=[{'type':'eq', 'fun':constr}],method="SLSQP",
                        options={'maxiter':300})



print("Home edge points: {:.3f}".format(res.x[ghome]))
print()


for i, t in enumerate(teams):
    print("{:s},{:.3f}".format(t, (res.x[i])))

